function reminderFox_upload_Startup()
{
  statustxt(reminderFox_getBundle().getString("rf.upload.ready.label"),0);
  setTimeout(sendData, 0);
}

function reminderFox_upload_closeWindow() {
 	if ( window.arguments != null && window.arguments[0].closeOnNoErrors == 1) {
  		close();
  	}
  	else {
 	  	var reminderFox_upload_button= document.getElementById("reminderFox_upload_button");
  	  	reminderFox_upload_button.setAttribute("label",reminderFox_getBundle().getString("rf.net.done") ); 	
  	}
}
function sendData()
{
  var _uploadURL = "";
  var _ioService = Components.classes["@mozilla.org/network/io-service;1"]
               	   .getService(Components.interfaces.nsIIOService);

  var proto = reminderFox_prefs.getCharPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_PROTO);
  var address = reminderFox_prefs.getCharPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_ADDRESS);
  var _username = reminderFox_prefs.getCharPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_USERNAME);
  
  var loginData = {
    ljURL : proto + "://" + address,
    username : _username,
    password : ''
  };

  loginData = reminderFox_getPassword(loginData);

  if (loginData.password == null) {
  	// no password found on password manager - user HAS TO set this password first!
    	uploadCallback(reminderFox_getBundle().getString("rf.upload.noPasswordSet.label"),-1);
  }

  _uploadURL = proto + "://" + _username + ":" + loginData.password + "@" + address;
 
  statustxt(reminderFox_getBundle().getString("rf.upload.exporting.label"),0);
  var i;

  // escape all commas
  var reminderFoxEvents = reminderFox_getReminderEvents();
  for ( i = 0; i < reminderFoxEvents.length; i++ ) {
	reminderFoxEvents[i].summary = reminderFoxEvents[i].summary.replace(/,/g,"\\,")
  }
  var reminderFoxTodos = reminderFox_getReminderTodos();
  for ( i = 0; i < reminderFoxTodos.length; i++ ) {
	reminderFoxTodos[i].summary = reminderFoxTodos[i].summary.replace(/,/g,"\\,")
  }

  var str=reminderFox_constructReminderOutput(reminderFoxEvents, reminderFoxTodos, true);;

  var uploadURI = _ioService.newURI(_uploadURL,null,null);
  var mimetype = "txt/xml; charset=UTF-8"; 

  if(!str)
  {
    uploadCallback(reminderFox_getBundle().getString("rf.net.done"),-3);
    return;
  }else if( ! gUploadService.start(str,
                                    uploadURI,
                                    mimetype,uploadCallback))
    uploadCallback(reminderFox_getBundle().getString("rf.net.done"),-1);
}

function uploadCallback(aStatus,aError)
{

  reminderFox_logMessageLevel(new Date() + "Uploaded reminders...", REMINDER_FOX_LOG_LEVEL_FINE);
  if(aStatus != reminderFox_getBundle().getString("rf.net.done") && aError==0) {
    statustxt(aStatus,aError);
    return;
   }

  switch(aError){
    case -2:
      statustxt(aStatus,aError);
      break;
    case 0:
       	if ( !(window.arguments != null && window.arguments[0].closeOnNoErrors == 1)) {
      		 statustxt(aStatus,aError);
      	}
      break;
    case -3:
      statustxt(reminderFox_getBundle().getString("rf.upload.sourceFileNotFound.label"),0);
      break;
    case 201:
      statustxt(reminderFox_getBundle().getString("rf.upload.created.label"),0);
      break;
    default:
      statustxt(aStatus,aError);
      return;
      break;
  }
  
  reminderFox_upload_closeWindow();

}

function statustxt(aStatus,aError)
{
  document.getElementById("status").value =(aError)?getErrorMsg(aError):aStatus;
}

function cancelUpload()
{
  gUploadService.cancel();
	close();
}


function getErrorMsg(aStatus)
{
  if(aStatus==0)
    return reminderFox_getBundle().getString("rf.ok");;

  var status=aStatus % 0x804b0000;
  var error=reminderFox_getBundle().getString("rf.upload.unexpected.label");
  switch(status)
  {
    case 1:
      error=reminderFox_getBundle().getString("rf.upload.unexpected.label");
      break;
    case 2:
      error=reminderFox_getBundle().getString("rf.upload.usercancel.label");
      break;
    case 13:
      error=reminderFox_getBundle().getString("rf.upload.refused.label");
      break;
    case 14:
      error=reminderFox_getBundle().getString("rf.upload.netTimeout.label");
      break;
    case 16:
      error=reminderFox_getBundle().getString("rf.upload.netOffline.label");
      break;
    case 21:
      error=reminderFox_getBundle().getString("rf.upload.loginfailure.label");
      break;
    case 22:
      error=reminderFox_getBundle().getString("rf.upload.ftpcwd.label");
      break;
    case 23:
      error=reminderFox_getBundle().getString("rf.upload.ftppasv.label");
      break;
    case 24:
      error=reminderFox_getBundle().getString("rf.upload.ftppwd.label");
      break;
    case 25:
      error=reminderFox_getBundle().getString("rf.upload.ftplist.label");
      break;
    case 30:
      error=reminderFox_getBundle().getString("rf.upload.unknown.label");
      break;
    case 201:
      statustxt(reminderFox_getBundle().getString("rf.upload.created.label"),0);
      break;
    case 401:
      error=reminderFox_getBundle().getString("rf.upload.loginfailure.label");
      break;
    case 405:
      error=reminderFox_getBundle().getString("rf.upload.methodNotAllowed.label");
      break;
    case 409:
      error=reminderFox_getBundle().getString("rf.upload.DestFileNotDefined.label");
      break;
    default:
      error=reminderFox_getBundle().getString("rf.upload.unexpected.label");
      break;
  }

  var formatted= (aStatus<0x804b0000)?
          aStatus.toString(10) : "0x" + aStatus.toString(16).toUpperCase();
  return  error + " (" + formatted + ")\n";
}
